// 1233 Matus Horvath

// pouzivame Dijkstrov algoritmus

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

struct tVrchol {
	double X;				// suradnice vrcholu
	double Y;
	double L;				// znacka
	int P;
	int Zaradeny;	// oznacuje, ci je tento vrchol este nevyrieseny
};

int main() {
	int PocetLetisk;
	double Dolet;
	tVrchol *Vrcholy;

//	FILE *fin=fopen("sept5.in","rt");
//	FILE *fout=fopen("sept5.out","wt");

	char buf[40];
	int i,u;


	sscanf(fgets(buf,40,stdin),"%d",&PocetLetisk);
	sscanf(fgets(buf,40,stdin),"%lf",&Dolet);

	Vrcholy=(tVrchol *)malloc(PocetLetisk*sizeof(tVrchol));

	for(i=0L;i<PocetLetisk;i++) {
		sscanf(fgets(buf,40,stdin),"%lf,%lf",&(Vrcholy[i].X),&(Vrcholy[i].Y));
		Vrcholy[i].L=1e100;
		Vrcholy[i].P=i;
		Vrcholy[i].Zaradeny=1;
	}

	// hladame cestu z ciela do startu, abuy sme na konci mali spravne
	// usporiadane letiska

	// takze sme na letisku 1 (ciel)
	Vrcholy[1].L=0;

	// a kym sme nespracovali letisko 0 (start) vykonavame nasledujuce
	while(Vrcholy[0].Zaradeny) {
		// najdeme zaradeny vrchol s najmensim L (oznacime ho u)
		// vrchol 0 je urcite este zaradeny, tak ho pouzijeme ako referenciu
		u=0;
		for(i=0;i<PocetLetisk;i++)
			if((Vrcholy[i].Zaradeny)&&(Vrcholy[i].L<Vrcholy[u].L)) u=i;

		// vyradime tento vrchol
		Vrcholy[u].Zaradeny=0;

		// pre vsetky ostatne zaradene vrcholy i vykonaj
		double Vzdialenost,VzdialX,VzdialY;

		for(i=0;i<PocetLetisk;i++) {
			// vypocitaj vzdialenost vrcholu i od vrcholu u
			VzdialX=Vrcholy[i].X-Vrcholy[u].X;
			VzdialY=Vrcholy[i].Y-Vrcholy[u].Y;
			Vzdialenost=sqrt(VzdialX*VzdialX+VzdialY*VzdialY);

			// ak lietadlo doleti na toto letisko i z letiska u
			if(Dolet>Vzdialenost) {
				// ak sa do i vieme dostat rychlejsie cez u ako doteraz
				if(Vrcholy[i].L>Vrcholy[u].L+Vzdialenost) {
					// tak je to kratsia cesta
					Vrcholy[i].L=Vrcholy[u].L+Vzdialenost;
					Vrcholy[i].P=u;
				}
			}
		}
	}

	// vypiseme dlzku
	fprintf(stdout,"%.3lf\n",Vrcholy[0].L);

	// vypiseme cestu od startu
	u=0;
	// kym sme nevypisali vsetky letiska az po ciel
	while(u!=1) {
		fprintf(stdout,"%.3lf,%.3lf\n",Vrcholy[u].X,Vrcholy[u].Y);
		u=Vrcholy[u].P;
	}
	// potom vypis ciel
	fprintf(stdout,"%.3lf,%.3lf\n",Vrcholy[1].X,Vrcholy[1].Y);

	free(Vrcholy);

//	fclose(fin);
//	fclose(fout);

	return 0;
}


